/* libsizzle/profile.h - interpreter profiling
 
  Copyright (C) 2000 Martin Grabmueller <mgrabmue@cs.tu-berlin.de>
 
  This is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2, or (at your option)
  any later version.
  
  This software is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this package; see the file COPYING.  If not, write to the
  Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
  MA 02111-1307, USA.  */

#ifndef __SIZZLE_PROFILE_H__
#define __SIZZLE_PROFILE_H__

#if HAVE_CONFIG_H
# include <config.h>
#endif 

#if __SIZZLE_IMPORT__
# define SIZZLE_API __declspec (dllimport)
#elif __SIZZLE_EXPORT__ 
# define SIZZLE_API __declspec (dllexport)
#else
# define SIZZLE_API
#endif

SIZZLE_API extern unsigned zzz_global_accesses;
SIZZLE_API extern unsigned zzz_lloc_accesses;
SIZZLE_API extern unsigned zzz_gloc_accesses;
SIZZLE_API extern unsigned zzz_tail_calls;
SIZZLE_API extern unsigned zzz_evaluate_calls;
SIZZLE_API extern unsigned zzz_closure_calls;
SIZZLE_API extern unsigned zzz_primitive_calls;
SIZZLE_API extern unsigned zzz_immediate_calls;
SIZZLE_API extern unsigned zzz_syntactic_calls;

#define PROFILE_INTERPRETER 1

#if PROFILE_INTERPRETER
# define PROFILE_COUNT(var) (var)++
#else /* !PROFILE_INTERPRETER */
# define PROFILE_COUNT(var) /* No operation */
#endif /* !PROFILE_INTERPRETER */

/* Initialize the profiling support module.  */
SIZZLE_API result_t zzz_init_profile (void);

#endif /* not __SIZZLE_PROFILE_H__ */
