/* libsizzle/scmport.h - Scheme port handling
 
  Copyright (C) 2000 Martin Grabmueller <mgrabmue@cs.tu-berlin.de>
 
  This is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2, or (at your option)
  any later version.
  
  This software is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this package; see the file COPYING.  If not, write to the
  Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
  MA 02111-1307, USA.  */

#ifndef __SIZZLE_SCMPORT_H__
#define __SIZZLE_SCMPORT_H__

#if HAVE_CONFIG_H
# include <config.h>
#endif 

#if __SIZZLE_IMPORT__
# define SIZZLE_API __declspec (dllimport)
#elif __SIZZLE_EXPORT__ 
# define SIZZLE_API __declspec (dllexport)
#else
# define SIZZLE_API
#endif

#include "node.h"

/* Type descriminator and accessor macros for string ports.  */
#define scmport_p(c)    (port_p(c) && port_ptype(c) == zzz_scmport_port_type)
#define scmport_pos(c)  (((zzz_scm_t) port_info(c))->fpos)

/* The port type identifier for string ports.  */
SIZZLE_API extern zzz_object_t zzz_scmport_port_type;

/* Create a Scheme port with a given procedure vector @var{proc_vec}.  */
SIZZLE_API zzz_scm_t zzz_make_scmport (zzz_scm_t proc_vec);

/* Initialize the Scheme port module.  */
SIZZLE_API result_t zzz_init_scmport (void);

#endif /* not __SIZZLE_SCMPORT_H__ */
