/* libsizzle/sig.h - signal handling code
 
  Copyright (C) 2000 Martin Grabmueller <mgrabmue@cs.tu-berlin.de>
 
  This is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2, or (at your option)
  any later version.
  
  This software is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this package; see the file COPYING.  If not, write to the
  Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
  MA 02111-1307, USA.  */

#ifndef __SIZZLE_SIG_H__
#define __SIZZLE_SIG_H__

#if HAVE_CONFIG_H
# include <config.h>
#endif 

#if __SIZZLE_IMPORT__
# define SIZZLE_API __declspec (dllimport)
#elif __SIZZLE_EXPORT__ 
# define SIZZLE_API __declspec (dllexport)
#else
# define SIZZLE_API
#endif

/* Number of currently pending signals.  If greater than zero, the
   function zzz_internal_handle_signals() should be called as soon as
   possible to dispatch to the possibly registered Scheme signal
   handlers.  */
SIZZLE_API extern int zzz_signal_count;

/* This is the function which gets called when a signal request was
   noticed.  Not for application use.  */
SIZZLE_API result_t zzz_internal_handle_signals (zzz_scm_t * result);

/* Initialize the signal handling module.  */
SIZZLE_API result_t zzz_init_sig (void);

/* Finalize the signal handing module.  All signal handlers are reset
   to SIG_DFL.  */
SIZZLE_API result_t zzz_finalize_sig (void);

#endif /* not __SIZZLE_SIG_H__ */
