dnl Automake macros for working with Sizzle.

dnl Original Guile version is Copyright (C) 1998 Free Software Foundation, Inc.
dnl Portions Copyright (C) 2000 Martin Grabmueller <mgrabmue@cs.tu-berlin.de>

dnl SIZZLE_FLAGS --- set flags for compiling and linking with Sizzle
dnl 
dnl This macro runs the `sizzle-config' script, installed with Sizzle,
dnl to find out where Sizzle's header files and libraries are
dnl installed.  It sets the following two variables:
dnl
dnl SIZZLE_CFLAGS: flags to pass to a C or C++ compiler to build
dnl	code that uses Sizzle header files.
dnl
dnl SIZZLE_LDFLAGS: flags to pass to the linker to link a
dnl	program against Sizzle.  This includes `-lsizzle' for
dnl	the Sizzle library itself, any libraries that Sizzle
dnl	itself requires (like -lm), and so on.  It may
dnl	also include a -L flag to tell the compiler where to
dnl	find the libraries.

AC_DEFUN([SIZZLE_FLAGS],[
  AC_MSG_CHECKING(for Sizzle)
  sizzle-config link > /dev/null || {
    echo "configure: cannot find sizzle-config; is Sizzle installed?" 1>&2
    exit 1
  }
  SIZZLE_CFLAGS="`sizzle-config compile`"
  SIZZLE_LDFLAGS="`sizzle-config link`"
  AC_SUBST(SIZZLE_CFLAGS)
  AC_SUBST(SIZZLE_LDFLAGS)
  AC_MSG_RESULT(yes)
])
